<?php
/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog SiteCalendar Block version 2.1                                    |
// | Tested with Geeklog version 1.3.7 release                                 |
// +---------------------------------------------------------------------------+
// | cal_block.php                                                             |
// | Main program to view site calendar that displays GL Calendar              |
// | events and hooks into the GL search to show any site updates              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000,2001 by the following authors:                         |
// | Geeklog Author: Tony Bibbs       - tony@tonybibbs.com                     |
// | Block Author:   Blaine Lang      - geeklog@langfamily.ca                  |
// | Original PHP Calendar by Scott Richardson - srichardson@scanonline.com	   |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// Release History
/********************************************************************************
* June 12/2002: Blaine Lang                                                     *
* Modified to work with Geeklog - structured as functions                       *
* and building HTML output to be called as a phpblock and                       *
*                                                                               *
* Sept 2/02: Fixed a bug where today was not being higlighted in the next month *
* Changed all occurances of $InThisMonth to $GLOBALS['InThisMonth']             *
*                                                                               *
* Sept 15/02: Version 2.0                                                       *
* ALmost a complete re-write, code restructured                                 *
* Integrated vesion with Site Search and Events Calendar                        *
* Displayed dates are now active hyperlinks to search results for that day      *
* Added ability to view next/prev months                                        *
* Now using Template classes for fonts                                          *
* Fixed bug with extra week showing up occasionally                             *
*                                                                               *
* Sept 16/02: Fixed bug where I was not checking access to events that were     *
* displayed on the calendar - added access checks.                              *
* Note: Currently only checking system calendar for events  - not personal      *
* Nov 08/02: Gorka Olaizola <gorka@escomposlinux.org>                           *
* 	Cleaned up source                                                           *
*	Fixed dates when week starts in previous month                              *
*	Fixed dates when switching years                                            *
*	Added setlocale and strftime for printing the month in local language       *
*                                                                               *
* Dec 03/02: Replaced a couple HTML fixes that had been made since the version  *
* used by Gorka when he did his changes                                         *
*                                                                               *
*********************************************************************************/


function display_calendar() {
    global $HTTP_POST_VARS,$_TABLES,$_CONF;
	
	setlocale("LC_TIME", "");
	if( !isset($HTTP_POST_VARS['month']) ) {
		$WorkDate = date("m/d/Y");
	}
	else{
		$WorkDate = $HTTP_POST_VARS['month'];
		$GLOBALS['WorkDate'] = $WorkDate;
	}
	$PrevMonth = date("m/d/Y", strtotime($WorkDate . "-1 month"));
	$NextMonth = date("m/d/Y", strtotime($WorkDate . "+1 month"));
	$Today = date("j", strtotime($WorkDate));
	$DaysThisMonth = mycalDaysInMonth(date("m/d/Y",strtotime($WorkDate)));
	$DaysLastMonth = mycalDaysInMonth(date("m/d/Y", strtotime ($PrevMonth)));
	
	$GLOBALS['InThisMonth'] = -1;
	$CurrentDay = GetStartingPoint($DaysLastMonth);

	$BlockDisplay = "<html><head></head>";

	//Header with Month Title and Next/Prev buttons
	$loc = $PHP_SELF;
	$BlockDisplay .= "<body topmargin='0' leftmargin='0' marginheight='0' marginwidth='0'>";
	$BlockDisplay .= "<table class='mycalTitle' height='100%' width='100%' border='1'><tr>";
	$BlockDisplay .= "<td colspan='7' height='8%' align='center' >";
	$BlockDisplay .= "<table height='100%' width='100%' border='0'><tr>";
    
	$BlockDisplay .= "<td class='mycalTitle' align='center'>";
	$BlockDisplay .= "<font size='2'><b>".ucfirst(strftime("%B %Y", strtotime($WorkDate)))."</b></font></td>";
	
	$BlockDisplay .= "</table>"; 
    // Main Calendar
	$BlockDisplay .= "</td></tr><tr>";
	$BlockDisplay .= "<td height='8%' align='center' valign='top' width='15%' class='mycalTitle'><font size='1'><b>Su</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Mo</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Tu</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>We</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Th</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='14%' class='mycalTitle'><font size='1'><b>Fr</b></font></td>";
	$BlockDisplay .= "<td align='center' valign='top' width='15%' class='mycalTitle''><font size='1'><b>Sa</b></font></td></tr>";
	
	
	for($x=1;$x<7;$x++){
		$BlockDisplay .= "<tr>";
		for($i=1;$i<8;$i++){
			$BlockDisplay .= "<td align='left' valign='top' height='14%' ";

			$event_url = mycal_eventurl($WorkDate, $CurrentDay, $GLOBALS['InThisMonth']);
			$BlockDisplay .= $event_url;
			$CurrentDay++;
					    
			$BlockDisplay .= "</center></td>";

			if( $GLOBALS['InThisMonth'] == -1 && $CurrentDay > $DaysLastMonth ){
				$CurrentDay = 1;
				$GLOBALS['InThisMonth'] = 0;
			}
			elseif($GLOBALS['InThisMonth'] == 0 && $CurrentDay > $DaysThisMonth ){
				$CurrentDay = 1;
				$GLOBALS['InThisMonth'] = 1;
			}
		}

		$BlockDisplay .= "</tr>";
		// Check to see if I need to display another week
		if ($GLOBALS['InThisMonth']==1) {
			break;
		}
		
	}

	$BlockDisplay .= "</table>";
	$BlockDisplay .= "<table height='100%' width='100%' border='0'><tr>";
	$BlockDisplay .= "<td>";	
	$BlockDisplay .= "<form method='post' action='$loc' >";
    $BlockDisplay .= "<input type='submit' value=' < '>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$PrevMonth'>";
    $BlockDisplay .= "</form></td>";
	$BlockDisplay .= "<td align='center'><font size='-2'>"._mycal_ClickonDate."</font></td>";
	$BlockDisplay .= "<td>";	
	$BlockDisplay .= "<form align='right' method='post' action='$loc' >";
    $BlockDisplay .= "<input type='submit' value=' > '>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$NextMonth'>";
    $BlockDisplay .= "</form></td>";
	$BlockDisplay .= "</table>";

	return $BlockDisplay;

}
	function mycalDaysInMonth($dt) {
		return date("t",strtotime($dt));
	}

	function GetStartingPoint($DLM){
	global $InthisMonth;
		$today = getdate(strtotime($GLOBALS['WorkDate']));
		$mday = $today['mday'];
		$mday-=1;
		$FirstOfMonth = date("m/d/Y",strtotime($GLOBALS['WorkDate'] . "-" . $mday . " days"));

		// Determine which day of the week the first day of this month starts on
		switch(date("l",strtotime($FirstOfMonth))){
		case "Sunday":
			$CD = 1;
			$GLOBALS['InThisMonth'] = 0;
			break;

		case "Monday":
			$CD = $DLM;
			break;

		case "Tuesday":
			$CD = $DLM-1;
			break;

		case "Wednesday":
			$CD = $DLM-2;
			break;

		case "Thursday":
			$CD = $DLM-3;
			break;

		case "Friday":
			$CD = $DLM-4;
			break;

		case "Saturday":
			$CD = $DLM-5;
		}

		return $CD;
	}

	function GetThisDate($SelectedDay){
		$today = getdate(strtotime($GLOBALS['WorkDate']));
		$mon = $today['mon'];
		$myear = $today['year'];
		return date("m/d/Y", strtotime($mon."/".$SelectedDay."/".$myear));
	}
	
	// support date format as : 23 1 2003, 23-01-2003, 23/01/2003, 
	// return timestamp
	function mycal_eventurl($WorkDate, $CurrentDay, $nextmonth='0'){
	    global $_TABLES,$_CONF;

	    $HighlightToday = false;
			$SecondsSinceEpoch = strtotime($WorkDate);

			$eventyear = date("Y", $SecondsSinceEpoch);
			$eventmonth = date("n", $SecondsSinceEpoch) + $nextmonth;
			if ($eventmonth>12) {
				$eventmonth=1;
				$eventyear++;
			} elseif ($eventmonth<1) {
					$eventmonth=12;
					$eventyear--;
				}

		$eventchk_date = $eventyear ."-".$eventmonth."-". $CurrentDay;
		$eventday = $CurrentDay++;

		if (date("m/Y") == date("m/Y", $SecondsSinceEpoch) && $eventday==date("d")) {
			$HighlightToday = true;
		}
		
		$eventSql = "SELECT eid, title,url,datestart,dateend,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon  FROM {$_TABLES['events']} WHERE datestart = '$eventchk_date'";
		$result = DB_query($eventSql);
		$theEvent= DB_fetchArray($result);

		if ((DB_numrows($result) > 0) && 
		    (SEC_hasAccess($theEvent['owner_id'],$theEvent['group_id'],$theEvent['perm_owner'],$theEvent['perm_group'],$theEvent['perm_members'],$theEvent['perm_anon']) > 0)) {
				$event_title = $theEvent['title'];
				if ($HighlightToday){
					$class="mycalTodayHighlight";
				}else{
					$class="mycalEventHighlight";
				}
				$event_url .= 'class="'.$class.'"><center><a href="' .$_CONF["site_url"] .'/search.php?mode=mycal&date='.$eventchk_date.'" TITLE="'.$event_title.'"><b>'.$eventday.'</b></a>';
				return $event_url;	
		} else {
		    if ($nextmonth != 0) {
				$event_url = 'class="mycalNextMonth"><center><a href="' .$_CONF["site_url"] .'/search.php?mode=mycal&date='.$eventchk_date.'">'.$eventday.'</a>';
			} else {
				if ($HighlightToday){
					$class="mycalTodayHighlight";
				}else{
					$class="mycalDateField";
				}
				$event_url .='class="'.$class.'"><center><a href="' .$_CONF["site_url"] .'/search.php?mode=mycal&date='.$eventchk_date.'"><b>'.$eventday.'</b></a>';
			}
			return $event_url;
		}
	}

?>